unit fMain;

interface

uses
  Forms, StdCtrls, Controls, Classes, SysUtils;

type
  TForm1 = class(TForm)
    Button1: TButton;
    ListBox1: TListBox;
    Button2: TButton;
    Edit1: TEdit;
    ComboBox1: TComboBox;
    procedure Button1Click(Sender: TObject);
    procedure Button2Click(Sender: TObject);
    procedure FormCreate(Sender: TObject);
  protected
    function ProcessStep1(const FileName: string; var ret: TStringList): Boolean;
    function ProcessStep2(L: TStringList; var ret: TStringList): Boolean;
    function split(S: string; var X: TStringList): Boolean;
    function Extract(S: string; Key: string): string; overload;
    function Extract(S: string): string; overload;
  end;

var
  Form1: TForm1;

implementation

{$R *.dfm}

//------------------------------------------------------------------------------
procedure TForm1.Button1Click(Sender: TObject);
var
  L1, L2: TStringList;
begin
  L1 := TStringList.Create;
  try
    if ProcessStep1('D:\INPUT.TXT', L1) then
    begin
      L2 := TStringList.Create;
      try
        if ProcessStep2(L1, L2) then
        begin
          //The final output
          ListBox1.Items.Text := L2.Text;
        end;
      finally
        FreeAndNil(L2);
      end;
    end;
  finally
    FreeAndNil(L1);
  end;
end;
//------------------------------------------------------------------------------
function TForm1.ProcessStep1(const FileName: string; var ret: TStringList): Boolean;
var
  I: Integer;
  L: TStringList;
  S, T: string;
begin
  if FileExists(FileName) then
  begin
    L := TStringList.Create;
    try
      L.LoadFromFile('D:\INPUT.TXT');
      I := 0;
      S := '';
      while I < L.Count do
      begin
        if Pos('dev name=', L[I]) > 0 then
        begin//New Item
          if S <> '' then ret.Add(S);
          S := Extract(L[I], 'dev name=');
        end
        else if Pos('dev ID=' , L[I]) > 0 then S := S + ',' + Extract(L[I], 'dev ID=')
        else if Pos('host ID=', L[I]) > 0 then S := S + ',' + Extract(L[I], 'host ID=')
        else if Pos('fscsi'   , L[I]) > 0 then
        begin
          T := Extract(L[I]);
          if T <> '' then S := S + ',' + T;
        end;
        Inc(I);
      end;
      if S <> '' then ret.Add(S);
    finally
      FreeAndNil(L);
    end;
  end;

  Result := ret.Count > 0;
  
end;
//------------------------------------------------------------------------------
function TForm1.ProcessStep2(L: TStringList; var ret: TStringList): Boolean;
const
  VALUE_COUNT = 16;//W[ѼƭӼ
var
  I, J: Integer;
  S: string;
  M: TStringList;
begin
  M := TStringList.Create;
  try
    for I := 0 to L.Count-1 do
    begin
      M.CommaText := L[I];
      M.Insert(1,Trim(Edit1.Text));     //JEdit1.TextĤGItem.
      S := 'insert into test  values('; //hinserte޸.
      for J := 0 to VALUE_COUNT-1 do
      begin
        if J < M.Count then S := S + '''' + M[J] + ''','
        else                S := S + ''''',';
      end;
      S[Length(S)] := ' ';//h̫@','
      S := Trim(S) + ');';//h̫ᤧ޸, å[W ';'.
      ret.Add(S);
    end;
  finally
    FreeAndNil(M);
  end;

  Result := ret.Count > 0;

end;
//------------------------------------------------------------------------------
function TForm1.split(S: string; var X: TStringList): Boolean;
var
  I: Integer;
begin
  if not Assigned(X) then X := TStringList.Create;
  X.Text := StringReplace(S,#32,#13,[rfReplaceAll,rfIgnoreCase]);
  //hťզC
  for I := X.Count-1 downto 0 do
    if Trim(X[I]) = '' then X.Delete(I);
  Result := X <> nil;
end;
//------------------------------------------------------------------------------
function TForm1.Extract(S: string; Key: string): string;
begin
  Result := S;
  if Length(Key) < Length(S) then
    Result := Copy(S, Length(Key)+1, Length(S)-Length(Key));
end;
//------------------------------------------------------------------------------
function TForm1.Extract(S: string): string;
var
  X: TStringList;
begin
  Result := '';
  if split(S, X) and (X.Count = 9) then
    Result := X[1]+','+X[2]+','+X[4];
  FreeAndNil(X);
end;
//------------------------------------------------------------------------------
procedure TForm1.FormCreate(Sender: TObject);
var
  I: Integer;
  S: string;
begin
  for I := 1 to 7 do
  begin
    S := '';
    if I and $01 > 0 then S := S + '1.txt,';
    if I and $02 > 0 then S := S + '2.txt,';
    if I and $04 > 0 then S := S + '3.txt,';
    S[Length(S)] := #$20;
    ComboBox1.Items.Add(Trim(S));
  end;
  ComboBox1.ItemIndex := 0;
end;
//------------------------------------------------------------------------------
procedure TForm1.Button2Click(Sender: TObject);
var
  S: string;
  I, J: Integer;
  fn, ret,F, T: TStringList;
begin
  ret := TStringList.Create;
  try
    fn := TStringList.Create;
    try
      fn.CommaText := ComboBox1.Items[ComboBox1.ItemIndex];
      if fn.Count > 0 then
      begin
        for I := 0 to fn.Count-1 do
          if FileExists('D:\'+fn[I]) then
          begin
            F := TStringList.Create;
            try
              F.LoadFromFile('D:\'+fn[I]);
              for J := 0 to F.Count-1 do
              begin
                S := Trim(F[J]);
                if(S[Length(S)]='r')and
                  (split(S, T))     and
                  (T.Count = 3)     then
                begin
                  ret.Add(T[0] + #$8 + T[1]);
                  T.Text := '';
                end;
              end;
            finally
              FreeAndNil(F);
            end;
          end;
      end;
    finally
      FreeAndNil(fn);
    end;

    //ܵG
    ret.SaveToFile('D:\RESULT.TXT');
    ListBox1.Items.Text := ret.Text;

  finally
    FreeAndNil(ret);
  end;
end;
//------------------------------------------------------------------------------

end.
